$regfile = "m8def.dat"                            '   .
$crystal = 12000000                               '  , .
$hwstack = 128                                    '  .
$swstack = 64                                     '   .
$framesize = 64

$baud = 9600

Declare Sub Termo_to_ind()

Config Portb = Output
Config Portc = Output

Dim I_dinamindex As Byte
Dim I_temp As Byte
Dim Temp As Byte
Dim Dinaminfo(4) As Byte
Dim 1wire_array(9) As Byte                        '  
Dim Currenttermo As Integer At 1wire_array Overlay
Dim Termo_out_buff As Integer
Dim Temp_i As Integer
Dim 1w_err As Byte                                '   1wire

$include "1Wire_Usart.bas"

Portc = 0
For Temp = 1 To 4
 Dinaminfo(temp) = 10
Next Temp


Config Timer0 = Timer , Prescale = 256            '   Timer1.
On Timer0 Dinam                                   '     Timer1
Enable Timer0                                     '    Timer1

Enable Interrupts

Do
   Gosub Gettermo
   Call Termo_to_ind()
Loop
End


Dinam:
 Incr I_dinamindex
 If I_dinamindex > 4 Then I_dinamindex = 1

 I_temp = Dinaminfo(i_dinamindex)

 Portc = 0
 Portb = Lookup(i_temp , Ind)
 If I_dinamindex = 2 Then Portb.7 = 0
 I_temp = 1
 Decr I_dinamindex
 Shift I_temp , Left , I_dinamindex
 Incr I_dinamindex

 Portc = I_temp

Return



Gettermo:
   1w_err = 0
   1wire_reset                                    '  .
   1w_err = 1wire_err()
   If 1w_err = 0 Then
     1wire_write &HCC                             '  "Skip ROM".
     1wire_write &H44                             '  "Convert  T".
     Waitms 800

     1wire_reset                                  '  .
     1w_err = 1wire_err()
     If 1w_err = 0 Then
       1wire_write &HCC                           '  "Skip ROM"
       1wire_write &HBE

       For Temp = 1 To 9
         1wire_array(temp) = 1wire_read()
       Next

       If 1wire_array(9) = Crc8(1wire_array(1) , 8) Then
          Currenttermo = Currenttermo * 10
          Shift Currenttermo , Right , 4 , Signed
       Else
         1w_err = 1
       End If

     End If

   Else
     Waitms 400
   End If
Return


Sub Termo_to_ind()
  Stop Timer0
   If 1w_err = 0 Then

      Termo_out_buff = Currenttermo

      If 1wire_array(2).7 = 1 Then
        Toggle Termo_out_buff
        Incr Termo_out_buff
      End If

      Dinaminfo(3) = 11
      Dinaminfo(4) = 11

      For Temp = 1 To 4
        Temp_i = Termo_out_buff Mod 10
        If Termo_out_buff > 0 Or Temp <= 2 Then
          Dinaminfo(temp) = Low(temp_i)
        Else
          If 1wire_array(2).7 = 1 Then
            Dinaminfo(temp) = 10
          End If
          Exit For
        End If
        Termo_out_buff = Termo_out_buff / 10
      Next

   Else
      Dinaminfo(4) = 12
      Dinaminfo(3) = 13
      Dinaminfo(2) = 14
      Dinaminfo(1) = 13
   End If
 Start Timer0
End Sub

Ind:
Data &B11000000                                   ' 0
Data &B11111001                                   ' 1
Data &B10100100                                   ' 2
Data &B10110000                                   ' 3
Data &B10011001                                   ' 4
Data &B10010010                                   ' 5
Data &B10000010                                   ' 6
Data &B11111000                                   ' 7
Data &B10000000                                   ' 8
Data &B10010000                                   ' 9
Data &B10111111                                   ' -
Data &B11111111                                   ' 
Data &B10000110                                   ' E
Data &B10101111                                   ' r
Data &B10100011                                   ' o